   int sensorPin = A0; //аналоговый ввод для выхода датчика 
   int dano=0;// переменная хранения данных датчика
    int ugol=90;// переменная хранения значения угла поворота стрелки
    char str[7]="";//для передачи значения угла на смартфон
    int pitanie=3;// вывод управления подачей питания
    int redjim=4;// вывод управления переключения режимов
    boolean flag_VOLT=true;//флаг режимов вольтметра (true) или амперметра (false)
    String inputString;// строки данных
    long Y1=0;
    int pV=830;//ПОДБИРАЮТ ИСХОДЯ ИЗ КОНКРЕТНЫХ ЗНАЧЕНИЙ R1,R2
    int pA=850;//ПОДБИРАЮТ ИСХОДЯ ИЗ КОНКРЕТНОГО ЗНАЧЕНИЯ R3
    void setup()
    {
    analogReference(INTERNAL);//делаем опорное напряжение на АЦП 1,1В 
    pinMode(pitanie, OUTPUT);
    digitalWrite(pitanie, HIGH);//подача команды на питание (HIGH), отключение (LOW)
    pinMode(redjim, OUTPUT);
    digitalWrite(redjim, LOW);//подача команды на режим вольтметр (LOW), амперметр (HIGH)
    Serial.begin(9600);
    }
    void loop()
    {
    dano=analogRead(sensorPin);  //
    if(dano!=0){Y1=millis();}//если произошло измерение величины перезапускаем таймер отключения
    if(millis()-Y1>60000){ digitalWrite(pitanie, LOW);}//выключаем прибор если не было измерений больше минуты
    if (flag_VOLT==true&&dano<=pV){ugol= map(dano, 0, pV, 90,0);}//преобразуем в угол поворота стрелки в приложении 
    if (flag_VOLT==false&&dano<=pA){ugol= map(dano, 0, pA, 90,0);}//преобразуем в угол поворота стрелки в приложении 
    if ((flag_VOLT==true&&dano>pV)||(flag_VOLT==false&&dano>pA)){ugol=400;digitalWrite(redjim, LOW);}//условия превышения пределов измерения
    sprintf(str, "%04d",ugol);// преобразуем значение угла в строку
    Serial.println(str);//отправляем в приложение
    delay_(500); //ждем 0,5 секунды
    }
/////////////////////////////////////////////////////////////////////////////////////////////////
//ФУНКЦИИ ПРИЁМА И ОБРАБОТКИ ДАННЫХ
void CheckSerial()
{
  //////////////////////////////////////////////////////////////////////////////
  while (Serial.available())//считываем строку данных пока они поступают
  {
    char inChar = (char)Serial.read();
    if (inChar == '\n')     //если окончание строки
    {
      MakeCmd();//обрабатываем её данной функцией
      break;
    }
    else inputString += inChar;// иначе удлиняем строку на один символ
  }
}
/////////////////////////////////////////////////////////////////////////////////
void MakeCmd()
{
  int y = inputString.length(); // присваиваем переменной у число символов в строке
  if (y < 1 || y > 1)return; //если их меньше 1 или больше, выходим из функции
  String cmd = inputString; // передаём строку другой переменной
  inputString = "";//"обнуляем переменную"
 if (cmd == "A") {
   flag_VOLT=false; digitalWrite(redjim, HIGH);//переход в режим амперметра
  }
 if (cmd == "B") {
   flag_VOLT=true; digitalWrite(redjim, LOW);//переход в режим вольтметра
  }
  
}
/////////////////////////////////////////////////////////////////////////////////
////  ФУНКЦИИ ОПИСАНИЕ // вместо задержки времени через delay  ///////////////////////////////////////
void delay_(int T1)
{
long Y=millis();

 while(millis()-Y<T1) 
  {
 CheckSerial();
  }
}
 ///////////////////////////////////////////////////////////////////////////////////////////////////////
